// sample.cpp : DLL AvP[VpɃGNX|[g֐`܂B
//

#include "stdafx.h"
#include <stdio.h>
#include "resource.h"
#include "aa2plugin.h"

// W[nh(dllmain.cppŒ`)
extern HMODULE moduleHandle;

// vOC̎
enum PluginType
{
	// ȃvOC
	PluginTypeInvalid = -1,

	// t@CvOC
	PluginTypeFile = 0,

	// C[WvOC
	PluginTypeImage,

	// tB^vOC
	PluginTypeFilter,

	// vOC̎ސ
	PluginTypeMax
};

// p[^
static const char* Parameter[PluginTypeMax] = {
	"file",
	"image",
	"filter",
};

// vOC
static const char* PluginName[PluginTypeMax] = 
{
	"Tvt@C",
	"TvC[W",
	"TvtB^",
};


//
// p[^vOCԂ
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// returnFvOC(40ȓ)Ap[^̏ꍇNULL
//
static int GetPluginType(const char* param)
{
	if (param)
	{
		for (int i = 0; i < PluginTypeMax; i++)
		{
			if (!_strnicmp(param, Parameter[i], strlen(Parameter[i])))
			{
				return i;
			}
		}
	}
	return PluginTypeInvalid;
}


//
// vOCԂ
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// returnFvOC(40ȓ)Ap[^̏ꍇNULL
//
PLUGIN_API const char* PluginGetName(const char* param)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	int type = GetPluginType(param);
	if (type < 0)
	{
		return NULL;
	}
	return PluginName[type];
}


// Ήgq
static const char* FileExt = "img";

//
// ΉgqԂ
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// returnFgq(8ȓ)Ap[^̏ꍇNULL
//
PLUGIN_API const char* FilePluginGetExt(const char* param)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFile)
	{
		return NULL;
	}

	return FileExt;
}


//
// [_[vOC̍ƃ\
//
typedef struct
{
	// t@Cnh
	HANDLE handle;

	// 摜̕
	int width;

	// 摜̍
	int height;

} LoaderPluginWork;


//
// ǂݍ݂̏s
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// filenameFt@C
// batchFꊇϊł̓ǂݍ݂ȂtrueAʏ̓ǂݍ݂Ȃfalse
// returnFȂƗp̃|C^AsȂNULL
//
PLUGIN_API void* LoaderPluginPrepare(const char* param, const char* filename, HWND parent, int* cancel, bool batch)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFile)
	{
		return NULL;
	}

	// ꊇϊ̏ꍇ̓_CAOJɕW̋Ńt@Cǂݍ
	// ̃Tvł̓IvVȂ̂ŗpȂ
	if (batch)
	{
	}

	// t@CJ
	HANDLE handle = CreateFileA(filename, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (handle == INVALID_HANDLE_VALUE)
	{
		return NULL;
	}

	// ƃm
	LoaderPluginWork* loader = new LoaderPluginWork;
	loader->handle = handle;
	loader->width = 0;
	loader->height = 0;
	return (void*)loader;
}


//
// ǂݍމ摜̏擾
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFLoaderPluginPrepareō쐬Ɨp̃|C^
// widthF摜̕
// heightF摜̍
// layerFC[
// canvasFLoXFAΉĂꍇ̂ݒlĕԂ
// brushFpX̃uVAΉĂꍇ̂ݒlĕԂ
// returnFȂtrueAsȂfalse
//
// LoaderPluginGetInfoLoaderPluginGetInfo2̂ǂ炩ĂB
// LoaderPluginGetInfo͉ʌ݊pȂ̂ŁAʏLoaderPluginGetInfo2ĂB
// Ăꍇ͏ʂ̊֐Ăяo܂B
// pXǂݍނɂLoaderPluginGetInfo2KvłB
//
PLUGIN_API bool LoaderPluginGetInfo2(const char* param, void* work, int* width, int* height, int* layer, DWORD* canvas, int* brush)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFile)
	{
		return false;
	}

	DWORD size;
	LoaderPluginWork* loader = (LoaderPluginWork*)work;

	// TCYǂݍ
	if ((!ReadFile(loader->handle, &loader->width, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	*width = loader->width;
	if ((!ReadFile(loader->handle, &loader->height, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	*height = loader->height;
	if ((!ReadFile(loader->handle, layer, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, canvas, sizeof(DWORD), &size, NULL)) || (size != sizeof(DWORD)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, brush, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}

	return true;
}


//
// pXuV擾
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFLoaderPluginPrepareō쐬Ɨp̃|C^
// brushFuVԍ(0`)
// dataFuVf[^
// returnFȂtrueAsȂfalse
//
PLUGIN_API bool LoaderPluginGetPathBrush(const char* param, void* work, int brush, PathBrush* data)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFile)
	{
		return false;
	}

	DWORD size;
	LoaderPluginWork* loader = (LoaderPluginWork*)work;

	// uVf[^ǂݍ
	if ((!ReadFile(loader->handle, &data->sizeMin, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->sizeMax, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->sizeJitter, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->alphaMin, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->alphaMax, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->between, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->pressSize, sizeof(BOOL), &size, NULL)) || (size != sizeof(BOOL)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->pressAlpha, sizeof(BOOL), &size, NULL)) || (size != sizeof(BOOL)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->recoating, sizeof(BOOL), &size, NULL)) || (size != sizeof(BOOL)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->gradation, sizeof(BOOL), &size, NULL)) || (size != sizeof(BOOL)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->gradationStart, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->angle, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->angleJitter, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->angleMove, sizeof(BOOL), &size, NULL)) || (size != sizeof(BOOL)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->type, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->patternID, sizeof(DWORD), &size, NULL)) || (size != sizeof(DWORD)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->tileScale, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}

	return true;
}


//
// C[̏擾
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFLoaderPluginPrepareō쐬Ɨp̃|C^
// layerFC[ԍ(0`)
// nameFC[Aő60AC[݂ꍇ̂ݒlĕԂ
// modeFZ[hAΉĂꍇ̂ݒlĕԂ
// alphaFl(0-100)AΉĂꍇ̂ݒlĕԂ
// visibleFC[ԂȂ1AsȂ0AΉĂꍇ̂ݒlĕԂ
// imageMaskF̃C[Ń}XNȂ1A}XNȂȂ0AΉĂꍇ̂ݒlĕԂ
// alphaMaskFsx̍XV}XNȂ1A}XNȂȂ0AΉĂꍇ̂ݒlĕԂ
// groupFO[vԍAΉĂꍇ̂ݒlĕԂ
// subLayerFTuC[t̃C[쐬ȂTuC[(0`)A`惌C[쐬Ȃ<0AΉĂꍇ̂ݒlĕԂ
// returnFȂtrueAsȂfalse
//
// LoaderPluginGetLayerInfoLoaderPluginGetLayerInfo2̂ǂ炩ĂB
// LoaderPluginGetLayerInfo͉ʌ݊pȂ̂ŁAʏLoaderPluginGetLayerInfo2ĂB
// Ăꍇ͏ʂ̊֐Ăяo܂B
// TuC[ǂݍނɂLoaderPluginGetLayerInfo2KvłB
//
PLUGIN_API bool LoaderPluginGetLayerInfo2(const char* param, void* work, int layer, char* name, int* mode, int* alpha, int* visible, int* imageMask, int* alphaMask, int* group, int* subLayer)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFile)
	{
		return false;
	}

	DWORD size;
	LoaderPluginWork* loader = (LoaderPluginWork*)work;

	// C[ǂݍ
	int len;
	if ((!ReadFile(loader->handle, &len, sizeof(int), &size, NULL)) || (size != sizeof(int)) || (len < 0) || (len > 60))
	{
		return false;
	}
	if ((len > 0) && ((!ReadFile(loader->handle, name, len, &size, NULL)) || (size != len)))
	{
		return false;
	}
	name[len] = '\0';

	// C[̏ǂݍ
	if ((!ReadFile(loader->handle, mode, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, alpha, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, visible, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, imageMask, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, alphaMask, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, group, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, subLayer, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}

	return true;
}


//
// TuC[̏擾
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFLoaderPluginPrepareō쐬Ɨp̃|C^
// layerFC[ԍ(0`)
// subLayerFTuC[ԍ(0`)
// nameFC[Aő60AC[݂ꍇ̂ݒlĕԂ
// modeFZ[hAΉĂꍇ̂ݒlĕԂ
// alphaFl(0-100)AΉĂꍇ̂ݒlĕԂ
// visibleFC[ԂȂ1AsȂ0AΉĂꍇ̂ݒlĕԂ
// imageMaskF̃C[Ń}XNȂ1A}XNȂȂ0AΉĂꍇ̂ݒlĕԂ
// alphaMaskFsx̍XV}XNȂ1A}XNȂȂ0AΉĂꍇ̂ݒlĕԂ
// groupFO[vԍAΉĂꍇ̂ݒlĕԂ
// pathCpFTuC[pXf[^ȂpX̐_(>0)A`惌C[Ȃ0AΉĂꍇ̂ݒlĕԂ
// returnFȂtrueAsȂfalse
//
// LoaderPluginGetSubLayerInfoLoaderPluginGetSubLayerInfo2̂ǂ炩ĂB
// LoaderPluginGetSubLayerInfo͉ʌ݊pȂ̂ŁAʏLoaderPluginGetSubLayerInfo2ĂB
// Ăꍇ͏ʂ̊֐Ăяo܂B
// pXf[^ǂݍނɂLoaderPluginGetSubLayerInfo2KvłB
//
PLUGIN_API bool LoaderPluginGetSubLayerInfo2(const char* param, void* work, int layer, int subLayer, char* name, int* mode, int* alpha, int* visible, int* imageMask, int* alphaMask, int* group, int* pathCp)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFile)
	{
		return false;
	}

	DWORD size;
	LoaderPluginWork* loader = (LoaderPluginWork*)work;

	// C[ǂݍ
	int len;
	if ((!ReadFile(loader->handle, &len, sizeof(int), &size, NULL)) || (size != sizeof(int)) || (len < 0) || (len > 60))
	{
		return false;
	}
	if ((len > 0) && ((!ReadFile(loader->handle, name, len, &size, NULL)) || (size != len)))
	{
		return false;
	}
	name[len] = '\0';

	// C[̏ǂݍ
	if ((!ReadFile(loader->handle, mode, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, alpha, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, visible, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, imageMask, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, alphaMask, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, group, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, pathCp, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}

	return true;
}


//
// C[̉摜擾
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFLoaderPluginPrepareō쐬Ɨp̃|C^
// layerFC[ԍ(0`)
// subLayerFTuC[ԍ(0`)
// pixelFsNZf[^(1sNZ4oCgŐA΁AԁȀ)AELoaderPluginGetInfoŕԂl
// returnFȂtrueAsȂfalse
//
// LoaderPluginGetLayerPixelLoaderPluginGetLayerPixel2̂ǂ炩ĂB
// LoaderPluginGetLayerPixel͉ʌ݊pȂ̂ŁAʏLoaderPluginGetLayerPixel2ĂB
// Ăꍇ͏ʂ̊֐Ăяo܂B
// TuC[ǂݍނɂLoaderPluginGetLayerPixel2KvłB
//
PLUGIN_API bool LoaderPluginGetLayerPixel2(const char* param, void* work, int layer, int subLayer, BYTE* pixel)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFile)
	{
		return false;
	}

	DWORD size;
	LoaderPluginWork* loader = (LoaderPluginWork*)work;

	// sNZǂݍ
	int total = loader->width * loader->height * sizeof(DWORD);
	if ((!ReadFile(loader->handle, pixel, total, &size, NULL)) || (size != total))
	{
		return false;
	}

	return true;
}


//
// pX̐_擾
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFLoaderPluginPrepareō쐬Ɨp̃|C^
// layerFC[ԍ(0`)
// subLayerFTuC[ԍ(0`)
// cpF_ԍ(0`)
// dataF_f[^
// returnFȂtrueAsȂfalse
//
PLUGIN_API bool LoaderPluginGetPathCp(const char* param, void* work, int layer, int subLayer, int cp, PathCP* data)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFile)
	{
		return false;
	}

	// _ǂݍ
	DWORD size;
	LoaderPluginWork* loader = (LoaderPluginWork*)work;
	if ((!ReadFile(loader->handle, &data->posX, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->posY, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->inDirX, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->inDirY, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->outDirX, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->outDirY, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->randSeed, sizeof(DWORD), &size, NULL)) || (size != sizeof(DWORD)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->drawColor, sizeof(DWORD), &size, NULL)) || (size != sizeof(DWORD)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->type, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->inPEType, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->inPEPlace, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->outPEType, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->outPEPlace, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->line, sizeof(BOOL), &size, NULL)) || (size != sizeof(BOOL)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->hide, sizeof(BOOL), &size, NULL)) || (size != sizeof(BOOL)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->brushId, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}

	return true;
}


//
// pX̐_擾
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFLoaderPluginPrepareō쐬Ɨp̃|C^
// layerFC[ԍ(0`)
// subLayerFTuC[ԍ(0`)
// dataFhԂf[^
// returnFȂtrueAsȂfalse
//
PLUGIN_API bool LoaderPluginGetPathFill(const char* param, void* work, int layer, int subLayer, PathFill* data)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFile)
	{
		return false;
	}

	// hԂǂݍ
	DWORD size;
	LoaderPluginWork* loader = (LoaderPluginWork*)work;
	if ((!ReadFile(loader->handle, &data->fillMethod, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->fillRegion, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->fillSeed, sizeof(DWORD), &size, NULL)) || (size != sizeof(DWORD)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->fillColor, sizeof(DWORD), &size, NULL)) || (size != sizeof(DWORD)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->gradationType, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->gradationSrcX, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->gradationSrcY, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->gradationDestX, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->gradationDestY, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->gradationDist, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->gradationRange, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->gradationSrcAlpha, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->gradationDestColor, sizeof(DWORD), &size, NULL)) || (size != sizeof(DWORD)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->gradationDestAlpha, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->gradationReverse, sizeof(BOOL), &size, NULL)) || (size != sizeof(BOOL)))
	{
		return false;
	}
	if ((!ReadFile(loader->handle, &data->brushId, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}

	return true;
}


//
// n
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFLoaderPluginPrepareō쐬Ɨp̃|C^
// returnFȂtrueAsȂfalse
//
PLUGIN_API bool LoaderPluginDispose(const char* param, void* work)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFile)
	{
		return false;
	}

	if (work)
	{
		LoaderPluginWork* loader = (LoaderPluginWork*)work;

		// t@C
		CloseHandle(loader->handle);

		// ƗpJ
		delete loader;
	}

	return true;
}


//
// Z[o[vOC̍ƃ\
//
typedef struct
{
	// ꎞt@C̃t@Cnh
	HANDLE handle;

	// ꎞt@C
	char tmpFile[MAX_PATH];

	// t@C
	char filename[MAX_PATH];

	// 摜̕
	int width;

	// 摜̍
	int height;

} SaverPluginWork;


//
// ꊇϊ̏s
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// parentFeEBhẼnh
// cancelFۑLZꍇ1Apꍇ0(ftHgjĕԂ
// returnFȂƗp̃|C^AsȂNULL
// ꊇϊɑΉȂꍇ͂̊֐𖢒`ɂ
//
PLUGIN_API void* SaverPluginBatchPrepare(const char* param, HWND parent, int* cancel)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFile)
	{
		return NULL;
	}

	// ꊇϊ̏ꍇ͂ŃIvV擾AƗpɕۑ
	// ̃Tvł̓IvVȂ̂ŗpȂ
	return (void*)true;
}


//
// ꊇϊ̌n
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// batchFSaverPluginBatchPrepareō쐬Ɨp̃|C^
// returnFȂtrueAsȂfalse
// ꊇϊɑΉȂꍇ͂̊֐𖢒`ɂ
//
PLUGIN_API bool SaverPluginBatchDispose(const char* param, void* batch)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFile)
	{
		return false;
	}

	// SaverPluginBatchPrepareō쐬ƗpJ
	// ̃Tvł̓IvVȂ̂ŗpȂ
	return true;
}


//
// s
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// filenameFt@C
// mergeFC[𓝍ԂŕۑȂ1(ftHg)AC[̂܂ܕۑȂ0ATuC[܂ŕۑȂ-1ĕԂ
// alphaFC[𓝍ꍇɃAt@lcȂ1ALoXFƍȂ0(ftHg)ĕԂ
// thresholdFwiFƍɓcȂ臒l(0-100)AwiFɒuȂ-1(ftHg)ĕԂ
// parentFeEBhẼnh
// cancelFۑLZꍇ1Apꍇ0(ftHgjĕԂ
// batchFꊇϊ̏ꍇSaverPluginBatchPrepareō쐬Ɨp̃|C^Aʏ̕ۑ̏ꍇNULL
// returnFȂƗp̃|C^AsȂNULL
//
PLUGIN_API void* SaverPluginPrepare(const char* param, const char* filename, int* merge, int* alpha, int* threshold, HWND parent, int* cancel, void* batch)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFile)
	{
		return false;
	}

	// ꊇϊ̏ꍇSaverPluginBatchPrepareŎ擾IvVŕۑ
	// ̃Tvł̓IvVȂ̂ŗpȂ
	if (batch)
	{
	}

	// TuC[̂܂ܕۑw
	*merge = -1;

	// ꎞt@C쐬(-13͖ɕt".tmp.xxxxxxxx"̕)
	int len = strnlen(filename, MAX_PATH + 1 - 13);
	if ((len <= 0) || (len >= MAX_PATH - 13))
	{
		return false;
	}
	char fnam[MAX_PATH];
	sprintf(fnam, "%s.tmp.%08x", filename, GetTickCount());
	HANDLE handle = CreateFileA(fnam, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (handle == INVALID_HANDLE_VALUE)
	{
		return NULL;
	}

	// ƃm
	SaverPluginWork* saver = new SaverPluginWork;
	saver->handle = handle;
	strcpy(saver->tmpFile, fnam);
	strcpy(saver->filename, filename);
	return (void*)saver;
}


//
// 摜̏ݒ肷
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFSaverPluginPrepareō쐬Ɨp̃|C^
// widthF摜̕
// heightF摜̍
// layerFC[
// canvasFLoXF
// brushFpX̃uV
// returnFȂtrueAsȂfalse
//
// SaverPluginSetInfoSaverPluginSetInfo2̂ǂ炩ĂB
// SaverPluginSetInfo͉ʌ݊pȂ̂ŁAʏSaverPluginSetInfo2ĂB
// Ăꍇ͏ʂ̊֐Ăяo܂B
// pXǂݍނɂSaverPluginSetInfo2KvłB
//
PLUGIN_API bool SaverPluginSetInfo2(const char* param, void* work, int width, int height, int layer, DWORD canvas, int brush)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFile)
	{
		return false;
	}

	DWORD size;
	SaverPluginWork* saver = (SaverPluginWork*)work;

	// TCY
	if ((!WriteFile(saver->handle, &width, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	saver->width = width;
	if ((!WriteFile(saver->handle, &height, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	saver->height = height;
	if ((!WriteFile(saver->handle, &layer, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &canvas, sizeof(DWORD), &size, NULL)) || (size != sizeof(DWORD)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &brush, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}

	return true;
}


//
// pXuVݒ肷
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFSaverPluginPrepareō쐬Ɨp̃|C^
// brushFuVԍ(0`)
// dataFuVf[^(brushSize̔z)
// returnFȂtrueAsȂfalse
//
PLUGIN_API bool SaverPluginSetPathBrush(const char* param, void* work, int brush, PathBrush* data)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	int type = GetPluginType(param);
	if (type < 0)
	{
		return false;
	}

	// uVf[^ۑ
	DWORD size;
	SaverPluginWork* saver = (SaverPluginWork*)work;
	if ((!WriteFile(saver->handle, &data->sizeMin, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->sizeMax, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->sizeJitter, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->alphaMin, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->alphaMax, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->between, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->pressSize, sizeof(BOOL), &size, NULL)) || (size != sizeof(BOOL)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->pressAlpha, sizeof(BOOL), &size, NULL)) || (size != sizeof(BOOL)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->recoating, sizeof(BOOL), &size, NULL)) || (size != sizeof(BOOL)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->gradation, sizeof(BOOL), &size, NULL)) || (size != sizeof(BOOL)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->gradationStart, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->angle, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->angleJitter, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->angleMove, sizeof(BOOL), &size, NULL)) || (size != sizeof(BOOL)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->type, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->patternID, sizeof(DWORD), &size, NULL)) || (size != sizeof(DWORD)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->tileScale, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}

	return true;
}


//
// C[̏ݒ肷
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFSaverPluginPrepareō쐬Ɨp̃|C^
// layerFC[ԍ(0`)
// nameFC[
// modeFZ[h
// alphaFl
// visibleFC[ԂȂ1AsȂ0
// imageMaskF̃C[Ń}XNȂ1A}XNȂȂ0
// alphaMaskFsx̍XV}XNȂ1A}XNȂȂ0
// groupFO[vID(1`)AO[vł͂Ȃꍇ0
// subLayerFTuC[A`惌C[̏ꍇ<0
// returnFȂtrueAsȂfalse
//
// SaverPluginSetLayerInfoSaverPluginSetLayerInfo2̂ǂ炩ĂB
// SaverPluginSetLayerInfo͉ʌ݊pȂ̂ŁAʏSaverPluginSetLayerInfo2ĂB
// Ăꍇ͏ʂ̊֐Ăяo܂B
// TuC[ۑɂSaverPluginSetLayerInfo2KvłB
//
PLUGIN_API bool SaverPluginSetLayerInfo2(const char* param, void* work, int layer, const char* name, int mode, int alpha, int visible, int imageMask, int alphaMask, int group, int subLayer)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFile)
	{
		return false;
	}

	DWORD size;
	SaverPluginWork* saver = (SaverPluginWork*)work;

	// C[
	int len = strlen(name);
	if ((len < 0) || (!WriteFile(saver->handle, &len, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((len >= 0) && ((!WriteFile(saver->handle, name, len, &size, NULL)) || (size != len)))
	{
		return false;
	}

	// C[̏
	if ((!WriteFile(saver->handle, &mode, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &alpha, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &visible, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &imageMask, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &alphaMask, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &group, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &subLayer, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}

	return true;
}


//
// TuC[̏ݒ肷
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFSaverPluginPrepareō쐬Ɨp̃|C^
// layerFC[ԍ(0`)
// subLayerFTuC[ԍ(0`)
// nameFC[
// modeFZ[h
// alphaFl
// visibleFC[ԂȂ1AsȂ0
// imageMaskF̃C[Ń}XNȂ1A}XNȂȂ0
// alphaMaskFsx̍XV}XNȂ1A}XNȂȂ0
// groupFO[vID(1`)AO[vł͂Ȃꍇ0
// pathCpFTuC[pXf[^ȂpX̐_(>0)A`惌C[Ȃ0
// returnFȂtrueAsȂfalse
//
// SaverPluginSetSubLayerInfoSaverPluginSetSubLayerInfo2̂ǂ炩ĂB
// SaverPluginSetSubLayerInfo͉ʌ݊pȂ̂ŁAʏSaverPluginSetSubLayerInfo2ĂB
// Ăꍇ͏ʂ̊֐Ăяo܂B
// pXf[^ۑɂSaverPluginSetSubLayerInfo2SaverPluginSetPathCpKvłB
//
PLUGIN_API bool SaverPluginSetSubLayerInfo2(const char* param, void* work, int layer, int subLayer, const char* name, int mode, int alpha, int visible, int imageMask, int alphaMask, int group, int pathCp)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFile)
	{
		return false;
	}

	DWORD size;
	SaverPluginWork* saver = (SaverPluginWork*)work;

	// C[
	int len = strlen(name);
	if ((len < 0) || (!WriteFile(saver->handle, &len, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((len >= 0) && ((!WriteFile(saver->handle, name, len, &size, NULL)) || (size != len)))
	{
		return false;
	}

	// C[̏
	if ((!WriteFile(saver->handle, &mode, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &alpha, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &visible, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &imageMask, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &alphaMask, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &group, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &pathCp, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}

	return true;
}


//
// C[̉摜ݒ肷
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFSaverPluginPrepareō쐬Ɨp̃|C^
// layerFC[ԍ(0`)
// subLayerFTuC[ԍ(0`)AC[̏ꍇ-1
// pixelFsNZf[^(1sNZ4oCgŐA΁AԁȀ)AESaverPluginSetInfoœnꂽl
// returnFȂtrueAsȂfalse
//
// SaverPluginSetLayerPixelSaverPluginSetLayerPixel2̂ǂ炩ĂB
// SaverPluginSetLayerPixel͉ʌ݊pȂ̂ŁAʏSaverPluginSetLayerPixel2ĂB
// Ăꍇ͏ʂ̊֐Ăяo܂B
// TuC[ۑɂSaverPluginSetLayerPixel2KvłB
// TuC[̓ǂݍݎɂ͓ǂݍ񂾃TuC[̉摜̂ŁAʏ̓C[̉摜̕ۑ͕spłB
//
PLUGIN_API bool SaverPluginSetLayerPixel2(const char* param, void* work, int layer, int subLayer, BYTE* pixel)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFile)
	{
		return false;
	}

	DWORD size;
	SaverPluginWork* saver = (SaverPluginWork*)work;

	// C[̉摜
	int total = saver->width * saver->height * sizeof(DWORD);
	if ((!WriteFile(saver->handle, pixel, total, &size, NULL)) || (size != total))
	{
		return false;
	}

	return true;
}


//
// pX̐_ݒ肷
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFSaverPluginPrepareō쐬Ɨp̃|C^
// layerFC[ԍ(0`)
// subLayerFTuC[ԍ(0`)
// cpF_ԍ(0`)
// dataF_f[^
// returnFȂtrueAsȂfalse
//
PLUGIN_API bool SaverPluginSetPathCp(const char* param, void* work, int layer, int subLayer, int cp, PathCP* data)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFile)
	{
		return false;
	}

	DWORD size;
	SaverPluginWork* saver = (SaverPluginWork*)work;

	// _
	if ((!WriteFile(saver->handle, &data->posX, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->posY, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->inDirX, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->inDirY, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->outDirX, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->outDirY, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->randSeed, sizeof(DWORD), &size, NULL)) || (size != sizeof(DWORD)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->drawColor, sizeof(DWORD), &size, NULL)) || (size != sizeof(DWORD)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->type, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->inPEType, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->inPEPlace, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->outPEType, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->outPEPlace, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->line, sizeof(BOOL), &size, NULL)) || (size != sizeof(BOOL)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->hide, sizeof(BOOL), &size, NULL)) || (size != sizeof(BOOL)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->brushId, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}

	return true;
}


//
// pX̐_ݒ肷
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFSaverPluginPrepareō쐬Ɨp̃|C^
// layerFC[ԍ(0`)
// subLayerFTuC[ԍ(0`)
// dataFhԂf[^
// returnFȂtrueAsȂfalse
//
PLUGIN_API bool SaverPluginSetPathFill(const char* param, void* work, int layer, int subLayer, PathFill* data)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFile)
	{
		return false;
	}

	DWORD size;
	SaverPluginWork* saver = (SaverPluginWork*)work;

	// hԂ
	if ((!WriteFile(saver->handle, &data->fillMethod, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->fillRegion, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->fillSeed, sizeof(DWORD), &size, NULL)) || (size != sizeof(DWORD)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->fillColor, sizeof(DWORD), &size, NULL)) || (size != sizeof(DWORD)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->gradationType, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->gradationSrcX, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->gradationSrcY, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->gradationDestX, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->gradationDestY, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->gradationDist, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->gradationRange, sizeof(float), &size, NULL)) || (size != sizeof(float)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->gradationSrcAlpha, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->gradationDestColor, sizeof(DWORD), &size, NULL)) || (size != sizeof(DWORD)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->gradationDestAlpha, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->gradationReverse, sizeof(BOOL), &size, NULL)) || (size != sizeof(BOOL)))
	{
		return false;
	}
	if ((!WriteFile(saver->handle, &data->brushId, sizeof(int), &size, NULL)) || (size != sizeof(int)))
	{
		return false;
	}

	return true;
}


//
// n
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFSaverPluginPrepareō쐬Ɨp̃|C^
// successFۑĂtrueArŎsĂfalse
// returnFȂtrueAsȂfalse
//
PLUGIN_API bool SaverPluginDispose(const char* param, void* work, bool success)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFile)
	{
		return false;
	}

	bool result = true;
	SaverPluginWork* saver = (SaverPluginWork*)work;
	if (saver)
	{
		if (success)
		{
			// ꎞt@C
			CloseHandle(saver->handle);

			// ރt@CmF
			DWORD attr = GetFileAttributesA(saver->filename);
			if (attr != 0xffffffff)
			{
				if (attr & FILE_ATTRIBUTE_DIRECTORY)
				{
					// fBNgȂ玸s
					result = false;
				}
				else
				{
					// ̃t@C폜
					if (!DeleteFileA(saver->filename))
					{
						result = false;
					}
				}
			}
			if (result)
			{
				// ꎞt@C̃t@CύX
				if (!MoveFileA(saver->tmpFile, saver->filename))
				{
					result = false;
				}
			}
			else
			{
				// sꍇ͈ꎞt@C폜
				DeleteFileA(saver->tmpFile);
			}
		}

		// ƗpJ
		delete saver;
	}

	return result;
}


//
// C[WvOC̍ƃ\
//
typedef struct
{
	// eEBhẼnh
	HWND parent;

	// 摜̕
	int width;

	// 摜̍
	int height;

	// sR[obN
	ImagePluginProcessCallback process;

	// _CAȌ
	int result;

	// C[
	int layer;

	// JgC[
	int currentLayer;

	// JgC[
	int currentSubLayer;

	// `F
	DWORD drawColor;

	// wiF
	DWORD bgColor;

	// 摜
	WordPixel* merge;

	// sNZ̑I̊AIꍇNULL
	BYTE* selRatio;
	
	// I͈
	RECT selRect;

	// R}h
	int command;

	// hԂF
	WordPixel fill;

	// O[vԍ
	int group;

	// Nbv͈
	RECT clipRect;

	// ΏۃC[
	int targetLayer;

	// ΏۃJgC[
	int targetSubLayer;

	// ꊇϊ̏ꍇImagePluginBatchPrepareō쐬Ɨp̃|C^Aʏ̕ۑ̏ꍇNULL
	void* batch;

	// 摜TCYύXłȂtrue
	bool size;

} ImagePluginWork;


//
// 摜_CAO֐
// hwndFEBhEnh
// msgFbZ[W
// wparamFp[^
// lparamFp[^
// returnFbZ[WTRUEAȂFALSE
//
static BOOL WINAPI ImageDialogProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
	switch (msg)
	{
	case WM_INITDIALOG:
		{
			// eEBhE~
			HWND parent = GetParent(hwnd);
			if (parent)
			{
				EnableWindow(parent, FALSE);
			}
		}
		return TRUE;

	case WM_COMMAND:
		{
			ImagePluginWork* image = (ImagePluginWork*)GetWindowLong(hwnd, GWL_USERDATA);
			if (!image)
			{
				break;
			}
			int command = 0;
			switch (LOWORD(wparam))
			{
			case IDOK:
				// I
				image->result = 1;
				SendMessage(hwnd, WM_CLOSE, 0, 0);
				break;

			case IDCANCEL:
				// LZ
				SendMessage(hwnd, WM_CLOSE, 0, 0);
				break;

			case IDC_RED_BUTTON:
				// ԐFœhԂ
				image->fill = WordPixel(RGB(255, 0, 0));
				command = LOWORD(wparam);
				break;

			case IDC_GREEN_BUTTON:
				// ΐFœhԂ
				image->fill = WordPixel(RGB(0, 255, 0));
				command = LOWORD(wparam);
				break;

			case IDC_BLUE_BUTTON:
				// FœhԂ
				image->fill = WordPixel(RGB(0, 0, 255));
				command = LOWORD(wparam);
				break;

			case IDC_MERGE_BUTTON:
			case IDC_QUARTER_BUTTON:
			case IDC_PHASE_BUTTON:
				command = LOWORD(wparam);
				break;
			}
			if (command != 0)
			{
				// R}hs
				image->command = command;
				if (image->process)
				{
					// ʏ̎s
					if (!image->process())
					{
						// s_CAO
						image->result = 0;
						SendMessage(hwnd, WM_CLOSE, 0, 0);
					}
				}
				else
				{
					// ꊇϊ̏ꍇ͏I
					image->result = 1;
					SendMessage(hwnd, WM_CLOSE, 0, 0);
				}
			}
		}
		return TRUE;

	case WM_CLOSE:
		{
			// eEBhEĊJ
			HWND parent = GetParent(hwnd);
			if (parent)
			{
				EnableWindow(parent, TRUE);
			}

			// EBhEj
			DestroyWindow(hwnd);
		}
		return TRUE;

	case WM_DESTROY:
		// f[^̊֘AtJ
		SetWindowLong(hwnd, GWL_USERDATA, (LONG)NULL);

		// _CAOI
		PostQuitMessage(0);
		return TRUE;
	}

	return FALSE;
}


//
// 摜_CAO\
// workFƗp̃|C^
// processFsR[obNAꊇϊ̏ꍇNULL
// returnFȂ>0AsȂ0AfȂ<0
//
static int ShowImageDialog(void* work, ImagePluginProcessCallback process)
{
	ImagePluginWork* image = (ImagePluginWork*)work;
	image->process = process;
	image->command = 0;
	image->result = -1;

	// _CAO쐬
	HWND dialog = CreateDialogA(moduleHandle, MAKEINTRESOURCEA(IDD_IMAGE_DIALOG), image->parent, ImageDialogProc);
	if (!dialog)
	{
		return 0;
	}

	// EBhEnhɃf[^֘At
	SetWindowLong(dialog, GWL_USERDATA, (LONG)image);

	// ꊇϊ̏ꍇ͌{^𖳌
	if (!process)
	{
		HWND item = GetDlgItem(dialog, IDOK);
		if (item)
		{
			EnableWindow(item, FALSE);
		}
	}

	// bZ[W[v
	MSG msg;
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!IsDialogMessage(dialog, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return image->result;
}


//
// 摜TCYύX邩ǂmF
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// returnF摜TCYύX\Ȃtrue
//
PLUGIN_API bool ImagePluginIsSizeChange(const char* param)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeImage)
	{
		return true;
	}

	return false;
}


//
// ꊇϊLǂmF
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// returnFꊇϊLȂtrue
// ̊֐`ĂȂꍇ́AImagePluginBatchPrepareImagePluginBatchDispose`ĂΈꊇϊLƔfB
// ̊֐1DLLŕ̋@\񋟂AꊇϊɑΉo@\ƏoȂ@\݂ꍇɕKvB
//
PLUGIN_API bool ImagePluginIsBatchEnable(const char* param)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeImage)
	{
		return false;
	}

	// ꊇϊ̑Ή󋵂Ԃ
	return true;
}


//
// tF[Y擾
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// returnFtF[Y(PhaseExecute~C[1tF[Y)Aő10
//
PLUGIN_API int ImagePluginGetPhase(const char* param)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeImage)
	{
		return 0;
	}

	// KvȍőtF[YԂ
	return 2;
}


//
// ꊇϊ̏s
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// parentFeEBhẼnh
// cancelFۑLZꍇ1Apꍇ0(ftHgjĕԂ
// returnFȂƗp̃|C^AsȂNULL
// ꊇϊɑΉȂꍇ͂̊֐𖢒`ɂ
//
PLUGIN_API void* ImagePluginBatchPrepare(const char* param, HWND parent, int* cancel)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeImage)
	{
		return NULL;
	}

	// ƃm
	ImagePluginWork* image = new ImagePluginWork;
	image->parent = parent;

	// _CAO\
	int result = ShowImageDialog(image, NULL);
	if (result <= 0)
	{
		if (result < 0)
		{
			*cancel = 1;
		}
		delete image;
		return NULL;
	}

	return (void*)image;
}


//
// ꊇϊ̌n
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// batchFImagePluginBatchPrepareō쐬Ɨp̃|C^
// returnFȂtrueAsȂfalse
// ꊇϊɑΉȂꍇ͂̊֐𖢒`ɂ
//
PLUGIN_API bool ImagePluginBatchDispose(const char* param, void* batch)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeImage)
	{
		return false;
	}

	// ƗpJ
	ImagePluginWork* image = (ImagePluginWork*)batch;
	if (image)
	{
		delete image;
	}

	return true;
}


//
// s
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// widthF摜̕
// heightF摜̍
// layerFC[
// currentLayerFJgC[AExecuteŃC[폜ꍇ͈Ȍ̎Qƕs
// currentSubLayerFJgC[AExecuteŃC[폜ꍇ͈Ȍ̎Qƕs
// drawColorF݂̕`F
// bgColorF݂̔wiF
// sizeF摜TCYύXłȂtrue
// parentFeEBhẼnh
// cancelFۑLZꍇ1Apꍇ0(ftHgjĕԂ
// batchFImagePluginBatchPrepareō쐬Ɨp̃|C^
// returnFȂƗp̃|C^AsȂNULL
//
// ImagePluginPrepareImagePluginPrepare2̂ǂ炩ĂB
// ImagePluginPrepare͉ʌ݊pȂ̂ŁAʏImagePluginPrepare2ĂB
// Ăꍇ͏ʂ̊֐Ăяo܂B
//
PLUGIN_API void* ImagePluginPrepare2(const char* param, int width, int height, int layer, int currentLayer, int currentSubLayer, DWORD drawColor, DWORD bgColor, bool size, HWND parent, int* cancel, void* batch)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeImage)
	{
		return false;
	}

	// ƃm
	ImagePluginWork* image = new ImagePluginWork;
	image->parent = parent;
	image->width = width;
	image->layer = layer;
	image->currentLayer = currentLayer;
	image->currentSubLayer = currentSubLayer;
	image->drawColor = drawColor;
	image->bgColor = bgColor;
	image->height = height;
	image->batch = batch;
	image->size = size;
	return (void*)image;
}


//
// _CAO\
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFImagePluginPrepareō쐬Ɨp̃|C^
// processFsR[obN
// returnFȂ>0AsȂ0AfȂ<0
//
PLUGIN_API int ImagePluginDialog(const char* param, void* work, ImagePluginProcessCallback process)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeImage)
	{
		return 0;
	}

	ImagePluginWork* image = (ImagePluginWork*)work;
	image->process = process;
	image->command = 0;
	image->result = 0;

	if (image->batch)
	{
		// ꊇϊ̍Ɨp̒lŎs
		ImagePluginWork* batch = (ImagePluginWork*)image->batch;
		switch (batch->command)
		{
		case IDC_RED_BUTTON:
		case IDC_GREEN_BUTTON:
		case IDC_BLUE_BUTTON:
			image->fill = batch->fill;
			image->command = batch->command;
			image->targetLayer = -1;
			image->targetSubLayer = -1;
			break;

		case IDC_MERGE_BUTTON:
		case IDC_QUARTER_BUTTON:
		case IDC_PHASE_BUTTON:
			image->command = batch->command;
			break;
		}
		if (image->command != 0)
		{
			// R}hs
			image->result = (image->process()) ? 1 : 0;
		}
		return image->result;
	}

	// _CAO\
	return ShowImageDialog(work, process);
}


//
// tF[YJn
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFImagePluginPrepareō쐬Ɨp̃|C^
// phaseFtF[Yԍ
// widthF摜̕AύXꍇ͒lύXĕԂ
// heightF摜̍AύXꍇ͒lύXĕԂ
// mergeF摜ATCYύXꍇ͈Ȍ̌Ăяoł͎Qƕs
// selRatioFsNZ̑I̊AIꍇNULLATCYύXꍇ͈Ȍ̌Ăяoł͎Qƕs
// selRectFI͈(E͈͂Ɋ܂܂)AIꍇ͖
// readOnlyFtF[Yɓǂݍ݂sȂꍇ0ȊO̒lԂ
// returnFȂ>0AsȂ0AtF[YXLbvȂ-1ALZȂ<-1
//
// tF[Y̎Ńf[^Ŵ߂̃tF[Y݂ꍇ́AreadOnlytOgpƓŖʂȃ삪ȂȂ܂B
//
PLUGIN_API int ImagePluginPhase2(const char* param, void* work, int phase, int* width, int* height, WordPixel* merge, BYTE* selRatio, RECT* selRect, int* readOnly)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeImage)
	{
		return 0;
	}

	ImagePluginWork* image = (ImagePluginWork*)work;

	// uO[vFvƁu2tF[YŐ؏ov{^ȊO1tF[Y
	if ((image->command != IDC_BLUE_BUTTON) && (image->command != IDC_PHASE_BUTTON) && (phase > 0))
	{
		return -1;
	}

	switch (image->command)
	{
	case IDC_RED_BUTTON:
	case IDC_GREEN_BUTTON:
	case IDC_BLUE_BUTTON:
		// I󋵂ۑ
		image->selRatio = selRatio;
		if (selRatio != NULL)
		{
			image->selRect = *selRect;
		}
		break;

	case IDC_MERGE_BUTTON:
		// C[ƌ摜ۑ
		image->merge = merge;
		break;

	case IDC_QUARTER_BUTTON:
		// cɂ
		if ((image->width <= 1) || (image->height <= 1))
		{
			return -1;
		}
		if (image->size)	// TCYύX\ȏꍇ̂ݕύX
		{
			*width = image->width >> 1;
			*height = image->height >> 1;
		}
		break;

	case IDC_PHASE_BUTTON:
		if (phase == 0)
		{
			// 1tF[Yڂŗ]TCY擾
			SetRect(&image->clipRect, 1, 1, 0, 0);
		}
		else if (phase == 1)
		{
			// 2tF[Yڂŗ]TCYɕύX
			int w = image->clipRect.right - image->clipRect.left;
			int h = image->clipRect.bottom - image->clipRect.top;
			if ((w <= 0) || (h <= 0))
			{
				// sNZ݂Ȃ΃XLbv
				return -1;
			}
			if ((w == image->width) && (h == image->height))
			{
				// TCYςȂ΃XLbv
				return -1;
			}
			*width = w;
			*height = h;
		}
		else
		{
			return -1;
		}
		break;
	}

	return 1;
}


//
// 摜s
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFImagePluginPrepareō쐬Ɨp̃|C^
// phaseFtF[Yԍ
// layerFC[ԍ(0`)
// subLayerFTuC[ԍ(0`)AC[g̏ꍇ<0
// groupFO[vԍ(1`)AO[vݒ肵ĂȂꍇ0AO[vɃC[1Ȃꍇ
// destPixelFsNZf[^(1sNZ8oCgŐԁA΁AȀ)AEPhaseŕԂl
// destRectFsNZ͈̔́AύXȂꍇ͒lύXȂ
// srcPixelFC[̃sNZf[^(1sNZ8oCgŐԁA΁AȀ)AEPhaseœnꂽl
// srcRectFC[̃sNŹ݂͈A͈͊ÕsNZ̓S~Ă̂ŎQƂȂALȃsNZ݂ȂꍇNULL
// adjustFImagePluginAdjustLocateňʒusΕ`悪sv̏ꍇtrue(destRectւ͕̑Kv)A`悪Kvȏꍇfalse
// removeFC[폜ꍇ1AC[ێꍇ0(ftHgjĕԂA폜ꍇ͈ȌĂяoŃC[ԍJオATuC[̏ꍇ͖
// visibleFC[\ԂȂ1A\ԂȂ0ĂBύXꍇ́ȀԂ̒lĕԂB
// calcFC[̉Z@(LayerCalc^)ĂBύXꍇ́ẢZ@ĕԂB
// alphaFC[̕sx(0`100)ĂBύXꍇ́A̒lĕԂB
// maskFC[̃C[Ń}XNĂȂ1A}XNĂȂȂ0ĂBύXꍇ́ȀԂ̒lĕԂB
// nameFC[Aő60BύXꍇ́A̕ĕԂB
// returnFȂtrueAsȂfalse
//
// ImagePluginExecuteImagePluginExecute2ImagePluginExecute3ImagePluginExecute4̂ǂꂩĂB
// ImagePluginExecuteAImagePluginExecute2AImagePluginExecute3͉ʌ݊pȂ̂ŁAʏImagePluginExecute4ĂB
// Ăꍇ͏ʂ̊֐Ăяo܂B
//
// TuC[ꍇ͍ŌɃTuC[̉摜̂ŁAeC[̉摜Kv͂܂destRectɕύX͈̔͂ĂB
// destRectɒlȂꍇAImagePluginPhase2readOnlytOݒ肵ĂȂꍇ̓TuC[؏܂B
// TuC[̖߂lfalseԂƐeC[`惌C[ɕύXAG[ɂ͂Ȃ܂B
//
PLUGIN_API bool ImagePluginExecute4(const char* param, void* work, int phase, int layer, int subLayer, int group, WordPixel* destPixel, RECT* destRect, WordPixel* srcPixel, RECT* srcRect, bool adjust, int* modify, int* visible, int* calc, int* alpha, int* mask, char* name)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeImage)
	{
		return false;
	}

	ImagePluginWork* image = (ImagePluginWork*)work;

	switch (image->command)
	{
	case IDC_RED_BUTTON:
	case IDC_GREEN_BUTTON:
	case IDC_BLUE_BUTTON:
	case IDC_MERGE_BUTTON:
		// ͈͂ݒ
		if (image->command == IDC_MERGE_BUTTON)
		{
			// TuC[͏Ȃ
			if (subLayer >= 0)
			{
				return false;
			}

			// 擪C[ȊO͍폜
			if (layer > 0)
			{
				*modify = LayerModifyRemove;
				return true;
			}

			// C[͕\Ԃɂ
			*visible = 1;

			// vZ@͒ʏ
			*calc = LayerCalcNormal;

			SetRect(destRect, 0, 0, image->width, image->height);
		}
		else
		{
			// sNZȂ΃XLbv
			if (!srcRect)
			{
				return true;
			}
			if (image->command == IDC_GREEN_BUTTON)
			{
				// JgC[ȊO̓XLbv
				if (layer != image->currentLayer)
				{
					// ΏۃC[ł͂Ȃ
					return true;
				}
				if (subLayer < 0)
				{
					// ΏۂTuC[̏ꍇAeC[ɂ͏͈͂Ԃď̓X[
					if (image->currentSubLayer >= 0)
					{
						*destRect = *srcRect;
						return true;
					}
				}
				else
				{
					if (image->currentSubLayer < 0)
					{
						// ΏۂeC[̏ꍇAqC[͕
						return false;
					}
					else if (subLayer != image->currentSubLayer)
					{
						// ΏۂTuC[̏ꍇAΏۃTuC[ȊO̓X[
						return true;
					}
				}
			}
			else if (image->command == IDC_BLUE_BUTTON)
			{
				if (image->currentSubLayer >= 0)
				{
					// JgTuC[̏ꍇATuC[Ώۂɂ
					if (layer != image->currentLayer)
					{
						// ʂ̐eC[ETuC[
						return true;
					}
					if (subLayer < 0)
					{
						// Jg̐eC[ɂ͏͈͂Ԃď̓X[
						*destRect = *srcRect;
						return true;
					}
				}
				else
				{
					// JgeC[̏ꍇATuC[̓X[
					if (subLayer >= 0)
					{
						return true;
					}
				}

				if (phase == 0)
				{
					// 1tF[YڂŃJgC[̃O[v擾
					if ((layer == image->currentLayer) && (subLayer == image->currentSubLayer))
					{
						image->group = group;
					}
					return true;
				}
				else
				{
					// 2tF[YڂŃJgC[ƓO[vȊO̓XLbv
					if ((image->group <= 0) || (group != image->group))
					{
						return true;
					}
				}

				// ꃌC[`惌C[ɂ邽߂ɑΏۃC[L^
				image->targetLayer = layer;
				image->targetSubLayer = subLayer;
			}
			*destRect = *srcRect;
		}
		for (int y = destRect->top; y < destRect->bottom; y++)
		{
			WordPixel* src = &srcPixel[y * image->width + destRect->left];
			WordPixel* dest = &destPixel[y * image->width + destRect->left];
			BYTE* sel = &image->selRatio[y * image->width + destRect->left];
			for (int x = destRect->left; x < destRect->right; x++)
			{
				if (image->command == IDC_MERGE_BUTTON)
				{
					*dest = image->merge[y * image->width + x];
				}
				else
				{
					// hׂ
					*dest = *src;
					if (dest->a > 0)
					{
						if (image->selRatio)
						{
							if ((x >= image->selRect.left) && (x <= image->selRect.right) && (y >= image->selRect.top) && (y <= image->selRect.bottom))
							{
								// IŃuh
								dest->Blend(WordPixel(image->fill.r, image->fill.g, image->fill.b, (WORD)(((DWORD)image->fill.a * (*sel)) / 255)));
							}
						}
						else
						{
							// IȂΓhԂ
							dest->Blend(image->fill, false);
						}
					}
				}
				src++;
				dest++;
				sel++;
			}
		}
		break;

	case IDC_QUARTER_BUTTON:
		if (srcRect)
		{
			int w = image->width >> 1;
			int h = image->height >> 1;
			for (int y = 0; y < image->height; y += 2)
			{
				WordPixel* dest = &destPixel[(y >> 1) * w];
				for (int x = 0; x < image->width; x += 2)
				{
					double r = 0.0;
					double g = 0.0;
					double b = 0.0;
					double a = 0.0;
					for (int yy = 0; yy < 2; yy++)
					{
						int ty = y + yy;
						for (int xx = 0; xx < 2; xx++)
						{
							int tx = x + xx;
							if ((tx >= srcRect->left) && (tx < srcRect->right) && (ty >= srcRect->top) && (ty < srcRect->bottom))
							{
								WordPixel* src = &srcPixel[ty * image->width + tx];
								if (src->a > 0)
								{
									double sa = (double)src->a / (WordPixel::ValueMax * 4);
									double d = (double)sa / WordPixel::ValueMax;
									r += src->r * d;
									g += src->g * d;
									b += src->b * d;
									a += sa;
								}
							}
						}
					}
					if (a > 0.001)
					{
						double t = WordPixel::ValueMax / a;
						*dest = WordPixel((WORD)(r * t), (WORD)(g * t), (WORD)(b * t), (WORD)(a * WordPixel::ValueMax));
					}
					else
					{
						*dest = WordPixel(0, 0, 0, 0);
					}
					dest++;
				}
			}

			// ͈͂ݒ
			SetRect(destRect, 0, 0, w, h);
		}
		break;

	case IDC_PHASE_BUTTON:
		if (phase == 0)
		{
			// 1tF[Yڂŗ]TCY擾
			// \̃C[̓TCYvZO
			if ((srcRect) && (*visible != 0))
			{
				if (image->clipRect.left > image->clipRect.right)
				{
					image->clipRect.left = srcRect->left;
					image->clipRect.right = srcRect->right;
				}
				else
				{
					image->clipRect.left = (image->clipRect.left < srcRect->left) ? image->clipRect.left : srcRect->left;
					image->clipRect.right = (image->clipRect.right > srcRect->right) ? image->clipRect.right : srcRect->right;
				}
				if (image->clipRect.top > image->clipRect.bottom)
				{
					image->clipRect.top = srcRect->top;
					image->clipRect.bottom = srcRect->bottom;
				}
				else
				{
					image->clipRect.top = (image->clipRect.top < srcRect->top) ? image->clipRect.top : srcRect->top;
					image->clipRect.bottom = (image->clipRect.bottom > srcRect->bottom) ? image->clipRect.bottom : srcRect->bottom;
				}
			}
		}
		else if (phase == 1)
		{
			// 2tF[Yڂŗ]TCYɕύX
			if (!srcRect)
			{
				return true;
			}
			int left = (srcRect->left >= image->clipRect.left) ? srcRect->left : image->clipRect.left;
			int top = (srcRect->top >= image->clipRect.top) ? srcRect->top : image->clipRect.top;
			int right = (srcRect->right <= image->clipRect.right) ? srcRect->right : image->clipRect.right;
			int bottom = (srcRect->bottom <= image->clipRect.bottom) ? srcRect->bottom : image->clipRect.bottom;

			// ͈͂ݒ
			int width = right - left;
			int height = bottom - top;
			SetRect(destRect, left - image->clipRect.left, top - image->clipRect.top, left + width, top + height);

			int clipWidth = image->clipRect.right - image->clipRect.left;
			for (int y = 0; y < height; y++)
			{
				WordPixel* src = &srcPixel[(y + top) * image->width + left];
				WordPixel* dest = &destPixel[(y + destRect->top) * clipWidth + destRect->left];
				for (int x = 0; x < width; x++)
				{
					*dest = *src;
					src++;
					dest++;
				}
			}

		}
		break;
	}

	return true;
}


//
// ꃌC[̈ʒuŎgpXP[l擾
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFImagePluginPrepareō쐬Ɨp̃|C^
// phaseFtF[Yԍ
// layerFC[ԍ(0`)
// xFx̃XP[lAg>1.0Ak<1.0A̒l𒲐ĕԂ
// yFỹXP[lAg>1.0Ak<1.0A̒l𒲐ĕԂ
//
// pX̃uVTCY̕ύXɗp܂B
// ۂ̃XP[OAdjustLocateōsĂB
//
PLUGIN_API void ImagePluginAdjustScale(const char* param, void* work, int phase, int layer, double* x, double* y)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeImage)
	{
		return;
	}

	ImagePluginWork* image = (ImagePluginWork*)work;

	switch (image->command)
	{
	case IDC_RED_BUTTON:
	case IDC_GREEN_BUTTON:
	case IDC_BLUE_BUTTON:
	case IDC_MERGE_BUTTON:
	case IDC_PHASE_BUTTON:
		// ύXȂ
		break;

	case IDC_QUARTER_BUTTON:
		// cɂ
		*x *= 0.5;
		*y *= 0.5;
		break;
	}
}


//
// ꃌC[̈ʒu𒲐
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFImagePluginPrepareō쐬Ɨp̃|C^
// phaseFtF[Yԍ
// layerFC[ԍ(0`)
// subLayerFTuC[ԍ(0`)AC[g̏ꍇ<0
// xFxWA̒l𒲐ĕԂ
// yFyWA̒l𒲐ĕԂ
// returnFꍇtrueAȂꍇfalse(ꃌC[`惌C[ɕύX)
//
// ImagePluginAdjustLocateImagePluginAdjustLocate2̂ǂ炩ĂB
// ImagePluginAdjustLocate͉ʌ݊pȂ̂ŁAʏImagePluginAdjustLocate2ĂB
// Ăꍇ͏ʂ̊֐Ăяo܂B
//
PLUGIN_API bool ImagePluginAdjustLocate2(const char* param, void* work, int phase, int layer, int subLayer, double* x, double* y)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeImage)
	{
		return false;
	}

	ImagePluginWork* image = (ImagePluginWork*)work;

	switch (image->command)
	{
	case IDC_RED_BUTTON:
	case IDC_MERGE_BUTTON:
		// `惌C[ɂ
		return false;

	case IDC_GREEN_BUTTON:
		if ((layer == image->currentLayer) && (subLayer == image->currentSubLayer))
		{
			// ΏۂTuC[̏ꍇ͕`惌C[ɂ邽߂falseԂ
			return false;
		}
		break;

	case IDC_BLUE_BUTTON:
		if ((layer == image->targetLayer) && (subLayer == image->targetSubLayer))
		{
			// ΏۃC[`惌C[ɂ邽߂falseԂ
			return false;
		}
		break;

	case IDC_QUARTER_BUTTON:
		// cɂ
		*x *= 0.5;
		*y *= 0.5;
		break;

	case IDC_PHASE_BUTTON:
		if (phase == 1)
		{
			// 2tF[Yڂňړ𒲐
			*x -= image->clipRect.left;
			*y -= image->clipRect.top;
		}
		break;
	}

	// ΏۊO̓ꃌC[ʂ߂ɒtrueԂ
	return true;
}


//
// n
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFImagePluginPrepareō쐬Ɨp̃|C^
// successFۑĂtrueArŎsĂfalse
// returnFȂtrueAsȂfalse
//
PLUGIN_API bool ImagePluginDispose(const char* param, void* work)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeImage)
	{
		return false;
	}

	// ƗpJ
	ImagePluginWork* image = (ImagePluginWork*)work;
	if (image)
	{
		delete image;
	}

	return true;
}


//
// tB^vOC̍ƃ\
//
typedef struct
{
	// eEBhẼnh
	HWND parent;

	// 摜̕
	int width;

	// 摜̍
	int height;

	// Ďs̏ꍇ͍Ďsf[^̃TCY(>=0)AĎsłȂ<0
	int rerunSize;

	// Ďs̏ꍇ͍Ďsf[^
	void* rerunData;

	// sR[obN
	FilterPluginProcessCallback process;

	// Ďsf[^ۑR[obN
	FilterPluginSaveRerunDataCallback rerun;

	// _CAȌ
	int result;

	// C[
	int layer;

	// R}h
	int command;

	// hԂF
	WordPixel fill;

	// ꊇϊ̏ꍇFilterPluginBatchPrepareō쐬Ɨp̃|C^Aʏ̕ۑ̏ꍇNULL
	void* batch;

} FilterPluginWork;


//
// 摜_CAO֐
// hwndFEBhEnh
// msgFbZ[W
// wparamFp[^
// lparamFp[^
// returnFbZ[WTRUEAȂFALSE
//
static BOOL WINAPI FilterDialogProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
	switch (msg)
	{
	case WM_INITDIALOG:
		{
			// eEBhE~
			HWND parent = GetParent(hwnd);
			if (parent)
			{
				EnableWindow(parent, FALSE);
			}
		}
		return TRUE;

	case WM_COMMAND:
		{
			FilterPluginWork* filter = (FilterPluginWork*)GetWindowLong(hwnd, GWL_USERDATA);
			if (!filter)
			{
				break;
			}
			int command = 0;
			switch (LOWORD(wparam))
			{
			case IDOK:
				// I
				if (filter->command != 0)
				{
					// Ďsf[^ۑ
					if (filter->rerun)
					{
						filter->rerun(sizeof(filter->command), &filter->command);
					}
				}
				filter->result = 1;
				SendMessage(hwnd, WM_CLOSE, 0, 0);
				break;

			case IDCANCEL:
				// LZ
				SendMessage(hwnd, WM_CLOSE, 0, 0);
				break;

			case IDC_RED_BUTTON:
				// ԐFœhԂ
				filter->fill = WordPixel(RGB(255, 0, 0));
				command = LOWORD(wparam);
				break;

			case IDC_GREEN_BUTTON:
				// ΐFœhԂ
				filter->fill = WordPixel(RGB(0, 255, 0));
				command = LOWORD(wparam);
				break;

			case IDC_BLUE_BUTTON:
				// FœhԂ
				filter->fill = WordPixel(RGB(0, 0, 255));
				command = LOWORD(wparam);
				break;

			case IDC_INSERT_BUTTON:
			case IDC_UNDER_BUTTON:
			case IDC_MERGE_BUTTON:
				command = LOWORD(wparam);
				break;
			}
			if (command != 0)
			{
				// R}hs
				filter->command = command;
				if (filter->process)
				{
					// ʏ̎s
					if (!filter->process())
					{
						// s_CAO
						filter->result = 0;
						SendMessage(hwnd, WM_CLOSE, 0, 0);
					}
				}
				else
				{
					// ꊇϊ̏ꍇ͏I
					filter->result = 1;
					SendMessage(hwnd, WM_CLOSE, 0, 0);
				}
			}
		}
		return TRUE;

	case WM_CLOSE:
		{
			// eEBhEĊJ
			HWND parent = GetParent(hwnd);
			if (parent)
			{
				EnableWindow(parent, TRUE);
			}

			// EBhEj
			DestroyWindow(hwnd);
		}
		return TRUE;

	case WM_DESTROY:
		// f[^̊֘AtJ
		SetWindowLong(hwnd, GWL_USERDATA, (LONG)NULL);

		// _CAOI
		PostQuitMessage(0);
		return TRUE;
	}

	return FALSE;
}


//
// tB^_CAO\
// workFƗp̃|C^
// processFsR[obNAꊇϊ̏ꍇNULL
// rerunFĎsf[^ۑR[obNAꊇϊ̏ꍇNULL
// returnFȂ>0AsȂ0AfȂ<0
//
static int ShowFilterDialog(void* work, FilterPluginProcessCallback process, FilterPluginSaveRerunDataCallback rerun)
{
	FilterPluginWork* filter = (FilterPluginWork*)work;
	filter->process = process;
	filter->rerun = rerun;
	filter->command = 0;
	filter->result = -1;

	// _CAO쐬
	HWND dialog = CreateDialogA(moduleHandle, MAKEINTRESOURCEA(IDD_FILTER_DIALOG), filter->parent, FilterDialogProc);
	if (!dialog)
	{
		return 0;
	}

	// EBhEnhɃf[^֘At
	SetWindowLong(dialog, GWL_USERDATA, (LONG)filter);

	// ꊇϊ̏ꍇ͌{^𖳌
	if (!process)
	{
		HWND item = GetDlgItem(dialog, IDOK);
		if (item)
		{
			EnableWindow(item, FALSE);
		}
	}

	// bZ[W[v
	MSG msg;
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!IsDialogMessage(dialog, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return filter->result;
}


//
// ꊇϊ̏s
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// parentFeEBhẼnh
// cancelFۑLZꍇ1Apꍇ0(ftHgjĕԂ
// returnFȂƗp̃|C^AsȂNULL
// ꊇϊɑΉȂꍇ͂̊֐𖢒`ɂ
//
PLUGIN_API void* FilterPluginBatchPrepare(const char* param, HWND parent, int* cancel)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFilter)
	{
		return NULL;
	}

	// ƃm
	FilterPluginWork* image = new FilterPluginWork;
	image->parent = parent;

	// _CAO\
	int result = ShowFilterDialog(image, NULL, NULL);
	if (result <= 0)
	{
		if (result < 0)
		{
			*cancel = 1;
		}
		delete image;
		return NULL;
	}

	return (void*)image;
}


//
// ꊇϊ̌n
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// batchFFilterPluginBatchPrepareō쐬Ɨp̃|C^
// returnFȂtrueAsȂfalse
// ꊇϊɑΉȂꍇ͂̊֐𖢒`ɂ
//
PLUGIN_API bool FilterPluginBatchDispose(const char* param, void* batch)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFilter)
	{
		return false;
	}

	// ƗpJ
	FilterPluginWork* image = (FilterPluginWork*)batch;
	if (image)
	{
		delete image;
	}

	return true;
}


//
// s
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// widthF摜̕
// heightF摜̍
// layerFC[
// rerunSizeFĎs̏ꍇ͍Ďsf[^̃TCY(>=0)AĎsłȂ<0
// rerunDataFĎs̏ꍇ͍Ďsf[^
// parentFeEBhẼnh
// cancelFۑLZꍇ1Apꍇ0(ftHgjĕԂ
// batchFFilterPluginBatchPrepareō쐬Ɨp̃|C^
// returnFȂƗp̃|C^AsȂNULL
//
PLUGIN_API void* FilterPluginPrepare(const char* param, int width, int height, int layer, int rerunSize, void* rerunData, HWND parent, int* cancel, void* batch)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFilter)
	{
		return false;
	}

	// ƃm
	FilterPluginWork* filter = new FilterPluginWork;
	filter->parent = parent;
	filter->width = width;
	filter->layer = layer;
	filter->height = height;
	filter->rerunSize = rerunSize;
	filter->rerunData = rerunData;
	filter->batch = batch;
	return (void*)filter;
}


//
// _CAO\
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFFilterPluginPrepareō쐬Ɨp̃|C^
// processFsR[obN
// rerunFĎsf[^ۑR[obN
// returnFȂ>0AsȂ0AfȂ<0
//
PLUGIN_API int FilterPluginDialog(const char* param, void* work, FilterPluginProcessCallback process, FilterPluginSaveRerunDataCallback rerun)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFilter)
	{
		return 0;
	}

	FilterPluginWork* filter = (FilterPluginWork*)work;
	filter->process = process;
	filter->rerun = rerun;
	filter->command = 0;
	filter->result = 0;

	if (filter->batch)
	{
		// ꊇϊ̍Ɨp̒lŎs
		FilterPluginWork* batch = (FilterPluginWork*)filter->batch;
		switch (batch->command)
		{
		case IDC_RED_BUTTON:
		case IDC_GREEN_BUTTON:
		case IDC_BLUE_BUTTON:
			filter->fill = batch->fill;
			filter->command = batch->command;
			break;

		case IDC_INSERT_BUTTON:
		case IDC_UNDER_BUTTON:
		case IDC_MERGE_BUTTON:
			filter->command = batch->command;
			break;
		}
		if (filter->command != 0)
		{
			// R}hs
			filter->result = (filter->process()) ? 1 : 0;
		}
		return filter->result;
	}

	if (filter->rerunSize >= 0)
	{
		// Ďs
		if (filter->rerunSize != sizeof(filter->command))
		{
			// Ďsf[^ُ
			return 0;
		}
		filter->command = *(int*)filter->rerunData;
		switch (filter->command)
		{
		case IDC_RED_BUTTON:
			// ԐFœhԂ
			filter->fill = WordPixel(RGB(255, 0, 0));
			break;

		case IDC_GREEN_BUTTON:
			// ΐFœhԂ
			filter->fill = WordPixel(RGB(0, 255, 0));
			break;

		case IDC_BLUE_BUTTON:
			// FœhԂ
			filter->fill = WordPixel(RGB(0, 0, 255));
			break;
		}
		if (process())
		{
			filter->result = 1;
		}
		return filter->result;
	}

	// _CAO\
	return ShowFilterDialog(work, process, rerun);
}


//
// 摜s
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFFilterPluginPrepareō쐬Ɨp̃|C^
// destPixelFsNZf[^(1sNZ8oCgŐԁA΁AȀ)AEPhaseŕԂl
// destRectFsNZ͈̔́AύXȂꍇ͒lύXȂ
// srcPixelFC[̃sNZf[^(1sNZ8oCgŐԁA΁AȀ)AEPhaseœnꂽl
// srcRectFC[̃sNŹ݂͈A͈͊ÕsNZ̓S~Ă̂ŎQƂȂALȃsNZ݂ȂꍇNULL
// mergeF摜
// createFʂVC[Ɋi[Ȃ0ȊOÃ݂C[Ɋi[Ȃ0(ftHg)ĕԂ
// insertFʂVC[ɓꍇ̑}ʒuĕԂAftHg݂͌̈ʒu
// returnFȂtrueAsȂfalse
//
PLUGIN_API bool FilterPluginExecute(const char* param, void* work, WordPixel* destPixel, RECT* destRect, WordPixel* srcPixel, RECT* srcRect, WordPixel* merge, int* create, int* insert)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFilter)
	{
		return false;
	}

	FilterPluginWork* filter = (FilterPluginWork*)work;

	switch (filter->command)
	{
	case IDC_RED_BUTTON:
	case IDC_GREEN_BUTTON:
	case IDC_BLUE_BUTTON:
		// ͈͂ݒ
		if (!srcRect)
		{
			return true;
		}
		*destRect = *srcRect;
		for (int y = destRect->top; y < destRect->bottom; y++)
		{
			WordPixel* src = &srcPixel[y * filter->width + destRect->left];
			WordPixel* dest = &destPixel[y * filter->width + destRect->left];
			for (int x = destRect->left; x < destRect->right; x++)
			{
				// hׂ
				*dest = *src;
				if (dest->a > 0)
				{
					dest->Blend(filter->fill, false);
				}
				src++;
				dest++;
			}
		}
		break;

	case IDC_INSERT_BUTTON:
	case IDC_UNDER_BUTTON:
		{
			// ͈͂ݒ
			SetRect(destRect, 0, 0, filter->width, filter->height);
			WordPixel fill(RGB(255, 0, 255));
			WordPixel trans(0, 0, 0, 0);
			for (int y = destRect->top; y < destRect->bottom; y++)
			{
				int ty = y & 8;
				WordPixel* dest = &destPixel[y * filter->width + destRect->left];
				for (int x = destRect->left; x < destRect->right; x++)
				{
					// s͗lɓhׂ
					int tx = x & 8;
					*dest =(tx == ty) ? fill : trans;
					dest++;
				}
			}

			// C[쐬w
			*create = 1;
			if (filter->command == IDC_UNDER_BUTTON)
			{
				// C[̍쐬ʒu1
				(*insert)++;
			}
		}
		break;

	case IDC_MERGE_BUTTON:
		{
			// ͈͂ݒ
			SetRect(destRect, 0, 0, filter->width, filter->height);
			for (int y = destRect->top; y < destRect->bottom; y++)
			{
				WordPixel* src = &merge[y * filter->width + destRect->left];
				WordPixel* dest = &destPixel[y * filter->width + destRect->left];
				for (int x = destRect->left; x < destRect->right; x++)
				{
					*dest++ = *src++;
				}
			}

			// C[쐬w
			*create = 1;

			// C[̍쐬ʒu擪
			*insert = 0;
		}
		break;
	}

	return true;
}


//
// n
// paramFvOCݒt@CɋLqp[^Ap[^ꍇNULL
// workFFilterPluginPrepareō쐬Ɨp̃|C^
// successFۑĂtrueArŎsĂfalse
// returnFȂtrueAsȂfalse
//
PLUGIN_API bool FilterPluginDispose(const char* param, void* work)
{
	// 1DLLŕ̋@\񋟂ꍇ̓p[^ɑΉs
	if (GetPluginType(param) != PluginTypeFilter)
	{
		return false;
	}

	// ƗpJ
	FilterPluginWork* filter = (FilterPluginWork*)work;
	if (filter)
	{
		delete filter;
	}

	return true;
}


